#!/usr/src/oisc/interpnew
#include "macros"
#include "libc"
#include "demostrs.h"

;DATA:
	buff:
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0

	buff2:
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
		0 0 0 0   0 0 0 0     0 0 0 0   0 0 0 0
	strstat: 0
	IMMED128: 128
	n1: 0
	n2: 0

;TEXT:

main:	NOP ;no initialization procedure needed
lbl0:	PRINTF(strissue) ;display issue
lbl1:	PRINTF(strlog) ;login prompt
	READLINE(buff) ;get login name
	STRCMP(buff,strguest,strstat) ;check if guest
	BEQ(strstat,TRUE,lblguest) ;goto label guest
	STRCMP(buff,strroot,strstat) ;check if root
	BEQ(strstat,TRUE,lblroot) ;goto label root
lblbad:	PRINTF(strbad) ;invalid login
	GOTO(lbl1) ;try again
lblroot:PRINTF(strpass) ;ask for password
	READLINE(buff) ;get password
	STRCMP(buff,strgrep,strstat) ;check if grep
	BNE(strstat,TRUE,lblbad) ;goto bad login
	PRINTF(strdie) ;inform of shutdown
die:	HALT ;shutdown

lblguest:
	PRINTF(strmotd) ;show motd
lp:	PRINTF(strprompt) ;show prompt
	READLINE(buff) ;get command
	LTRIM(buff,buff2) ;trim left whitespace
	STRREV2(buff2,buff)
	LTRIM(buff,buff2) ;trim right whitespace
	STRREV2(buff2,buff)
	CONDENSEWHITESPACE(buff,buff2) ;kill remaining whitespace
	MOV(ZERO,LOGOUTFLAG) ;reset logout flag
	NEWCALL(eval) ;evaluate
	BEQ(LOGOUTFLAG,ONE,lbl0) ;logout
	GOTO(lp) ;loop

LOGOUTFLAG: 0

eval:	;evaluate buff2
	STRCMP(buff2,strhelp,strstat) ;check for 'help' string
	BEQ(strstat,TRUE,disphelp)
	STRCMP(buff2,strset,strstat) ;check for 'set' string
	BEQ(strstat,TRUE,setram)
	STRCMP(buff2,strdump,strstat) ;check for 'dump' string
	BEQ(strstat,TRUE,dumpram)
	STRCMP(buff2,strlogout,strstat) ;check for 'logout' string
	BEQ(strstat,TRUE,logout)
	PRINTF(strbadcmd)
done:	RET

disphelp:
	PRINTF(strhelptext) ;display help info
	GOTO(done)
setram:
	PRINTF(strwhataddr) ;ask for address
	READLINE(buff) ;get address
	PRINTF(strwhatval) ;ask for value
	READLINE(buff2) ;get value
	ATOI(buff,n1)
	ATOI(buff2,n2)
	MOVI(n2,n1) ;set value
	GOTO(done)
dumpram:
	PRINTF(strstartaddr) ;ask for starting address
	READLINE(buff) ;get address 1
	PRINTF(strstopaddr) ;ask for stopping address
	READLINE(buff2) ;get address 2
	ATOI(buff,n1)
	ATOI(buff2,n2)
	MOV(n1,DUMPARG1)
	MOV(n2,DUMPARG2)
	NEWCALL(dump) ;dump ram
	GOTO(done)
logout:
	MOV(ONE,LOGOUTFLAG)
	GOTO(done)
